unit PAcmdU;

interface

uses
  SysUtils, Classes,IdBaseComponent, IdComponent,
  IdTCPConnection, IdTCPClient, IdHTTP, math;

type
  TPaCmdDevice = class(TDataModule)
    IdHTTP1: TIdHTTP;
  private
    { Private declarations }
    Flast_error: string;
    function Send_cmd(IP: string; const cmd: string; const resource: string = ''): boolean;
  public
    { Public declarations }
    function Speak(const IP: string; const text: string): boolean;
    function SetPhone(const ip: string; const PhoneNum: string; const Delay: integer): boolean;
    property Last_error: string read Flast_error;
  end;

var
  PaCmdDevice: TPaCmdDevice;

implementation

resourcestring
  StrSpeakNow = 'speaknow=';
  PA_PROTOCOL = 'http://';
  StrPhone = 'phone=';
  StrDelay = 'delay=';
  StrConfightm = 'config.htm';
{$R *.dfm}


function TPaCmdDevice.Send_cmd(IP: string; const cmd: string; const resource: string = ''): boolean;
const
  HTTP_STATUS_OK = 200;
  HTTP_STATUS_OK_END = 299;
var
  data: TStringList;
  rsp: string;
begin
  Data := TstringList.create;
  try
    if pos(PA_PROTOCOL, IP) <> 1 then
      IP := PA_PROTOCOL + IP;
    IdHTTP1.Request.Referer :=  Ip + '/' + resource;
    idhttp1.Request.Host := IP;
    ip := ip + '/' + resource;
    data.Text :=Cmd;
    Idhttp1.AllowCookies := TRUE;
  
    rsp := IdHTTP1.Post(IP, Data);
    result := (rsp <> '') and InRAnge(IdHTTP1.ResponseCode, HTTP_STATUS_OK, HTTP_STATUS_OK_END);
    Flast_error := rsp;
  finally
    FreeAndNil(data);
  end;
end;

function TPaCmdDevice.SetPhone(const ip: string; const PhoneNum: string; const Delay: integer): boolean;
begin
  result := Send_cmd(ip, StrPhone + PhoneNum + '&'+StrDelay+inttostr(delay), strconfightm);
end;

function TPaCmdDevice.Speak(const IP: string; const text: string): boolean;
begin
  result := Send_cmd(IP,  StrSpeakNow + text);
end;

end. {unit}
